
var renderClass = "jp.ngt.rtm.render.VehiclePartsRenderer";
importPackage(Packages.org.lwjgl.opengl);
importPackage(Packages.jp.ngt.rtm.render);
importPackage(Packages.jp.ngt.ngtlib.math);
importPackage(Packages.jp.ngt.rtm)
importPackage(Packages.jp.ngt.rtm.entity.train.util);
importPackage(Packages.jp.ngt.ngtlib.io);
importPackage(Packages.jp.ngt.rtm.entity.vehicle);
importPackage(Packages.jp.ngt.ngtlib.util);
importPackage(Packages.jp.ngt.ngtlib.renderer);
//データ保存処理(グローバル関数)
var LocalData = new java.util.HashMap();

//##### オブジェクト定義 ####################
function init(par1, par2) {
	//車体
	body = renderer.registerParts(new Parts("parts", "body", "body-s", "under", "hood-front", "AU411K", "top", "seat", "side", "hood", "int", "tsurikawa1", "tsurikawa2", "tsurikawa3", "lcd", "foot"));
	int1 = renderer.registerParts(new Parts("int1"));
	int2 = renderer.registerParts(new Parts("int2"));
	h1 = renderer.registerParts(new Parts("h1"));
	lightF1 = renderer.registerParts(new Parts("light-F1"));
	lightB1 = renderer.registerParts(new Parts("light-B1"));
	lightF2 = renderer.registerParts(new Parts("light-F2"));
	lightB2 = renderer.registerParts(new Parts("light-B2"));
	lightF3 = renderer.registerParts(new Parts("light-F3"));
	lightB3 = renderer.registerParts(new Parts("light-B3"));
	h2 = renderer.registerParts(new Parts("h2"));
	lightF4 = renderer.registerParts(new Parts("light-F4"));
	lightB4 = renderer.registerParts(new Parts("light-B4"));
	lightF5 = renderer.registerParts(new Parts("light-F5"));
	lightB5 = renderer.registerParts(new Parts("light-B5"));
	lightF6 = renderer.registerParts(new Parts("light-F6"));
	lightB6 = renderer.registerParts(new Parts("light-B6"));
	shikiriL = renderer.registerParts(new Parts("shikiriL"));
	shikiriA = renderer.registerParts(new Parts("shikiriA"));
	alpha = renderer.registerParts(new Parts("window"));
	door_LF = renderer.registerParts(new Parts("door_LF"));
	door_RF = renderer.registerParts(new Parts("door_RF"));
	door_LB = renderer.registerParts(new Parts("door_LB"));
	door_RB = renderer.registerParts(new Parts("door_RB"));
	door_LFa = renderer.registerParts(new Parts("door_LFa"));
	door_RFa = renderer.registerParts(new Parts("door_RFa"));
	door_LBa = renderer.registerParts(new Parts("door_LBa"));
	door_RBa = renderer.registerParts(new Parts("door_RBa"));

	//貫通路
	Fdoor_C = renderer.registerParts(new Parts("Fdoor_C"));
	Fdoor_O = renderer.registerParts(new Parts("Fdoor_O"));
	Fdoor_Cw = renderer.registerParts(new Parts("Fdoor_Cw"));
	Fdoor_Ow = renderer.registerParts(new Parts("Fdoor_Ow"));
	Fdoor_C1 = renderer.registerParts(new Parts("Fdoor_C1"));
	Fdoor_O1 = renderer.registerParts(new Parts("Fdoor_O1"));
	Fdoor_Cw1 = renderer.registerParts(new Parts("Fdoor_Cw1"));
	Fdoor_Ow1 = renderer.registerParts(new Parts("Fdoor_Ow1"));


	//パンタ
	pantabase = renderer.registerParts(new Parts("panta_AB1", "panta_AB2", "panta_A1", "panta_A2", "panta_B1", "panta_B2", "panta_C1", "panta_C2", "panta_D1", "panta_D2"));
	pantaA11 = renderer.registerParts(new Parts("panta_A1_1"));
	pantaA12 = renderer.registerParts(new Parts("panta_A1_2"));
	pantaA13 = renderer.registerParts(new Parts("panta_A1_3"));
	pantaA14 = renderer.registerParts(new Parts("panta_A1_4"));
	pantaA15 = renderer.registerParts(new Parts("panta_A1_5"));
	pantaA21 = renderer.registerParts(new Parts("panta_A2_1"));
	pantaA22 = renderer.registerParts(new Parts("panta_A2_2"));
	pantaA23 = renderer.registerParts(new Parts("panta_A2_3"));
	pantaA24 = renderer.registerParts(new Parts("panta_A2_4"));
	pantaA25 = renderer.registerParts(new Parts("panta_A2_5"));
	pantaB11 = renderer.registerParts(new Parts("panta_B1_1"));
	pantaB12 = renderer.registerParts(new Parts("panta_B1_2"));
	pantaB13 = renderer.registerParts(new Parts("panta_B1_3"));
	pantaB14 = renderer.registerParts(new Parts("panta_B1_4"));
	pantaB15 = renderer.registerParts(new Parts("panta_B1_5"));
	pantaB21 = renderer.registerParts(new Parts("panta_B2_1"));
	pantaB22 = renderer.registerParts(new Parts("panta_B2_2"));
	pantaB23 = renderer.registerParts(new Parts("panta_B2_3"));
	pantaB24 = renderer.registerParts(new Parts("panta_B2_4"));
	pantaB25 = renderer.registerParts(new Parts("panta_B2_5"));
	pantaC11 = renderer.registerParts(new Parts("panta_C1_1"));
	pantaC12 = renderer.registerParts(new Parts("panta_C1_2"));
	pantaC13 = renderer.registerParts(new Parts("panta_C1_3"));
	pantaC14 = renderer.registerParts(new Parts("panta_C1_4"));
	pantaC15 = renderer.registerParts(new Parts("panta_C1_5"));
	pantaC21 = renderer.registerParts(new Parts("panta_C2_1"));
	pantaC22 = renderer.registerParts(new Parts("panta_C2_2"));
	pantaC23 = renderer.registerParts(new Parts("panta_C2_3"));
	pantaC24 = renderer.registerParts(new Parts("panta_C2_4"));
	pantaC25 = renderer.registerParts(new Parts("panta_C2_5"));
	pantaD11 = renderer.registerParts(new Parts("panta_D1_1"));
	pantaD12 = renderer.registerParts(new Parts("panta_D1_2"));
	pantaD13 = renderer.registerParts(new Parts("panta_D1_3"));
	pantaD14 = renderer.registerParts(new Parts("panta_D1_4"));
	pantaD15 = renderer.registerParts(new Parts("panta_D1_5"));
	pantaD21 = renderer.registerParts(new Parts("panta_D2_1"));
	pantaD22 = renderer.registerParts(new Parts("panta_D2_2"));
	pantaD23 = renderer.registerParts(new Parts("panta_D2_3"));
	pantaD24 = renderer.registerParts(new Parts("panta_D2_4"));
	pantaD25 = renderer.registerParts(new Parts("panta_D2_5"));

	//幕(ひーさん制作オブジェクト定義)
	s_t = [];
	s_d = [];
	for (var i = 0; i < 34; i++) {
		var objName_t = "s_t" + i;
		var objName_d = "s_d" + i;
		s_t[i] = renderer.registerParts(new Parts(objName_t));
		s_d[i] = renderer.registerParts(new Parts(objName_d));
	}
}


function MCVersionChecker() {
	var varsion = RTMCore.VERSION;
	if (varsion.indexOf("1.7.10") >= 0) return "1.7.10";
	else if (varsion.indexOf("2.0") >= 0) return "1.8.9";
	else if (varsion.indexOf("2.1") >= 0) return "1.9.4";
	else if (varsion.indexOf("2.2") >= 0) return "1.10.2";
	else if (varsion.indexOf("2.4") >= 0) return "1.12.2";
	else return "unknown";
}

//##### 号車取得 ####################
function isMiddleCar(entity) {//trueなら中間車、falseなら先頭車/後尾車

	//-通さない処理-
	if (entity === null) return;
	//if (renderer.currentMatId !== 3) return;//材質でも走査されるため

	var data = LocalData.get(entity);//保存された"データ群"の呼び出し
	var state = false;

	var formation = entity.getFormation();//formation型
	if (formation == null) {//formationが取得できないときの処理
		state = data.prevstate;
		if (data.prevstate == null) state = false;
	} else {
		var current = formation.getEntry(entity).entryId + 1;//この車両の号車を取得。0から数えるため+1する
		var max = formation.size();//連結してる両数を返す
		if (current == 1 || current == max) {//この車両が先頭or最後尾なら
			state = false;
		} else {//そうでない(つまり中間)なら
			state = true;
		}
	}

	data.prevstate = state;
	LocalData.put(entity, data);

	return state;
}

//##### render ####################
function render(entity, pass, par3) {
	//データ保存処理の初期化
	//Entityをキーにしてるので競合を起こさない(setData/getDataのビットシフトより確実性が高い)
	//必ず一番最初に実行されるように書く
	var data = LocalData.get(entity) || {};
	LocalData.put(entity, data);

	var Middle = isMiddleCar(entity);
	var varsion = MCVersionChecker();

	//数値設定
	var doorMove = 0.64, //ドア開閉距離(m)
		pantaDistance = 6.225, //パンタ中心の前後位置(m)
		pantaType = "Compatible"; //パンタ高(Normal:標準-格納 / W51:W51-格納 / Compatible:標準-W51)

	GL11.glPushMatrix();


	//通常描画
	if (pass == 0) {
		body.render(renderer);
		render_door(entity, doorMove);
		render_light(entity, Middle, pass);
		render_sign(entity, pass, par3, Middle);
		render_panta(entity, pantaDistance, pantaType);
	}

	//半透明描画
	if (pass == 1) {
		if (varsion == "1.12.2") { //RTM1でない(RTM2であるとき)
			GLHelper.setBrightness(entity ? entity.func_70070_b() : 0); //明るさ再設定
		}
		alpha.render(renderer);
		render_door_a(entity, doorMove);
		render_sign(entity, pass, par3, Middle);
	}

	//発光部描画
	if (pass > 1) {
		body.render(renderer);
		render_light(entity, Middle, pass);
		render_door(entity, doorMove);
		render_sign(entity, pass, par3, Middle);
	}


	var intLight = 0;
	var varsion = MCVersionChecker();


	if (entity != null) {
		if (varsion == "1.7.10" || varsion == "1.8.9" || varsion == "1.9.4") {
			intLight = entity.getTrainStateData(5);
		} else {
			intLight = entity.getVehicleState(TrainState.getStateType(5));
		}

	}

	if (intLight == 0) {
		GL11.glPushMatrix();
		shikiriA.render(renderer);
		GL11.glPopMatrix();
	} else {
		GL11.glPushMatrix();
		shikiriL.render(renderer);
		GL11.glPopMatrix();
	}
	// 貫通路







	//##### render_運転室 ######

	var data = LocalData.get(entity);//保存された"データ群"の呼び出し
	var frontTrainName = "";
	var backTrainName = "";
	var Middle = isMiddleCar(entity);

	if (entity != null) {
		var frontTrain = entity.getConnectedTrain(0);
		var backTrain = entity.getConnectedTrain(1);
		var varsion = MCVersionChecker();
		var Frnt = 0;

		if (frontTrain != null) {
			if (varsion == "1.7.10" || varsion == "1.8.9" || varsion == "1.9.4") {
				frontTrainName = frontTrain.getModelName();
			} else {
				frontTrainName = frontTrain.getResourceState().getResourceName();
			}
		}

		if (Frnt != null) {
			if (varsion == "1.7.10" || varsion == "1.8.9" || varsion == "1.9.4") {
				Frnt = entity.getTrainStateData(10);

			} else {
				Frnt = entity.getVehicleState(TrainState.getStateType(10));
			}
		}

		if (backTrain != null) {
			if (varsion == "1.7.10" || varsion == "1.8.9" || varsion == "1.9.4") {
				backTrainName = backTrain.getModelName();
			} else {
				backTrainName = backTrain.getResourceState().getResourceName();
			}
		}
	}

	if (Frnt == 0) {
		GL11.glPushMatrix();
		int1.render(renderer);
		GL11.glPopMatrix();
		if (Middle == false) {
			Fdoor_C.render(renderer);
			Fdoor_Cw.render(renderer);
		} else {
			if (frontTrainName.indexOf("sCONJRKCT") != -1 && backTrainName.indexOf("sCONJRKCT") != -1) {
				Fdoor_O.render(renderer);
				Fdoor_Ow.render(renderer);
			} else {
				Fdoor_C.render(renderer);
				Fdoor_Cw.render(renderer);
			}
		}

	} else {
		GL11.glPushMatrix();
		int2.render(renderer);
		GL11.glPopMatrix();
		if (Middle == false) {
			Fdoor_C1.render(renderer);
			Fdoor_Cw1.render(renderer);
		} else {
			if (frontTrainName.indexOf("sCONJRKCT") != -1 && backTrainName.indexOf("sCONJRKCT") != -1) {
				Fdoor_O1.render(renderer);
				Fdoor_Ow1.render(renderer);
			} else {
				Fdoor_C1.render(renderer);
				Fdoor_Cw1.render(renderer);
			}
		}


	}


	GL11.glPopMatrix();

}







//##### render_ライト ####################
function render_light(entity, Middle, pass) {

	var varsion = MCVersionChecker();
	var lightMove = 0;
	var lighttype = 0;
	var headtype = 0;

	if (entity != null) {
		if (varsion == "1.7.10" || varsion == "1.8.9" || varsion == "1.9.4") {
			lightMove = entity.getTrainStateData(0);
			lighttype = entity.getTrainStateData(7);
			headtype = entity.getTrainStateData(11);
		} else {
			lightMove = entity.getVehicleState(TrainState.getStateType(0));
			lighttype = entity.getVehicleState(TrainState.getStateType(7));
			headtype = entity.getVehicleState(TrainState.getStateType(11));
		}

	}



	GL11.glPushMatrix();
	if (headtype == 0) {
		GL11.glPushMatrix();
		h2.render(renderer);
		GL11.glPopMatrix();


		if (Middle == false) {

			if (lightMove == 0) {
				if (lighttype == 0) {
					GL11.glPushMatrix();
					lightF4.render(renderer);
					GL11.glPopMatrix();
				} else {
					if (lighttype == 1) {
						GL11.glPushMatrix();
						lightF5.render(renderer);
						GL11.glPopMatrix();
					} else {
						GL11.glPushMatrix();
						lightF6.render(renderer);
						GL11.glPopMatrix();
					}
				}
			} else {
				if (lighttype == 0) {
					GL11.glPushMatrix();
					lightB4.render(renderer);
					GL11.glPopMatrix();
				} else {
					if (lighttype == 1) {
						GL11.glPushMatrix();
						lightB5.render(renderer);
						GL11.glPopMatrix();
					} else {
						GL11.glPushMatrix();
						lightB6.render(renderer);
						GL11.glPopMatrix();
					}
				}
			}
		} else {

			if (pass == 0) {
				if (lighttype == 0) {
					GL11.glPushMatrix();
					lightB4.render(renderer);
					GL11.glPopMatrix();
				} else {
					if (lighttype == 1) {
						GL11.glPushMatrix();
						lightB5.render(renderer);
						GL11.glPopMatrix();
					} else {
						GL11.glPushMatrix();
						lightB6.render(renderer);
						GL11.glPopMatrix();
					}
				}
			}

		}
	} else {
		GL11.glPushMatrix();
		h1.render(renderer);
		GL11.glPopMatrix();


		if (Middle == false) {

			if (lightMove == 0) {
				if (lighttype == 0) {
					GL11.glPushMatrix();
					lightF1.render(renderer);
					GL11.glPopMatrix();
				} else {
					if (lighttype == 1) {
						GL11.glPushMatrix();
						lightF2.render(renderer);
						GL11.glPopMatrix();
					} else {
						GL11.glPushMatrix();
						lightF3.render(renderer);
						GL11.glPopMatrix();
					}
				}
			} else {
				if (lighttype == 0) {
					GL11.glPushMatrix();
					lightB1.render(renderer);
					GL11.glPopMatrix();
				} else {
					if (lighttype == 1) {
						GL11.glPushMatrix();
						lightB2.render(renderer);
						GL11.glPopMatrix();
					} else {
						GL11.glPushMatrix();
						lightB3.render(renderer);
						GL11.glPopMatrix();
					}
				}
			}
		} else {

			if (pass == 0) {
				if (lighttype == 0) {
					GL11.glPushMatrix();
					lightB1.render(renderer);
					GL11.glPopMatrix();
				} else {
					if (lighttype == 1) {
						GL11.glPushMatrix();
						lightB2.render(renderer);
						GL11.glPopMatrix();
					} else {
						GL11.glPushMatrix();
						lightB3.render(renderer);
						GL11.glPopMatrix();
					}
				}
			}

		}

	}
	GL11.glPopMatrix();
}



//##### render_ドア ####################
function render_door(entity, doorMove) {

	var doorMoveL = 0.0,
		doorMoveR = 0.0;

	try {
		doorMoveL = renderer.sigmoid(entity.doorMoveL / 60) * doorMove;
		doorMoveR = renderer.sigmoid(entity.doorMoveR / 60) * doorMove;
	} catch (e) { }

	GL11.glPushMatrix();
	GL11.glTranslatef(0.0, 0.0, doorMoveL);
	door_LF.render(renderer);
	GL11.glPopMatrix();

	GL11.glPushMatrix();
	GL11.glTranslatef(0.0, 0.0, -doorMoveL);
	door_LB.render(renderer);
	GL11.glPopMatrix();

	GL11.glPushMatrix();
	GL11.glTranslatef(0.0, 0.0, doorMoveR);
	door_RF.render(renderer);
	GL11.glPopMatrix();

	GL11.glPushMatrix();
	GL11.glTranslatef(0.0, 0.0, -doorMoveR);
	door_RB.render(renderer);
	GL11.glPopMatrix();
}


//##### render_半透ドア ####################
function render_door_a(entity, doorMove) {

	var doorMoveL = 0.0,
		doorMoveR = 0.0;

	try {
		doorMoveL = renderer.sigmoid(entity.doorMoveL / 60) * doorMove;
		doorMoveR = renderer.sigmoid(entity.doorMoveR / 60) * doorMove;
	} catch (e) { }

	GL11.glPushMatrix();
	GL11.glTranslatef(0.0, 0.0, doorMoveL);
	door_LFa.render(renderer);
	GL11.glPopMatrix();

	GL11.glPushMatrix();
	GL11.glTranslatef(0.0, 0.0, -doorMoveL);
	door_LBa.render(renderer);
	GL11.glPopMatrix();

	GL11.glPushMatrix();
	GL11.glTranslatef(0.0, 0.0, doorMoveR);
	door_RFa.render(renderer);
	GL11.glPopMatrix();

	GL11.glPushMatrix();
	GL11.glTranslatef(0.0, 0.0, -doorMoveR);
	door_RBa.render(renderer);
	GL11.glPopMatrix();
}



//##### render_パンタ ####################
function render_panta(entity, pantaDistance, pantaType) {

	var pantaState = 0.0,
		pDis = pantaDistance;

	try {
		pantaState = renderer.sigmoid(entity.pantograph_F / 40);
	} catch (e) { }

	switch (pantaType) {
		case "W51":
			var pAro1 = pantaState * 18 + 15,
				pAro2 = pantaState * 37 + 26,
				pBro1 = pantaState * 15 + 12,
				pBro2 = pantaState * 39 + 27,
				pCro1 = pantaState * 15 + 14,
				pCro2 = pantaState * 35 + 24,
				pCro4 = pantaState * 36 + 24,
				pCro5 = pantaState * 38 + 28;
			break;
		case "Compatible":
			var pAro1 = pantaState * 15,
				pAro2 = pantaState * 26,
				pBro1 = pantaState * 12,
				pBro2 = pantaState * 27,
				pCro1 = pantaState * 14,
				pCro2 = pantaState * 24,
				pCro4 = pantaState * 24,
				pCro5 = pantaState * 28;
			break;
		default:
			var pAro1 = pantaState * 33,
				pAro2 = pantaState * 63,
				pBro1 = pantaState * 27,
				pBro2 = pantaState * 66,
				pCro1 = pantaState * 29,
				pCro2 = pantaState * 59,
				pCro4 = pantaState * 60,
				pCro5 = pantaState * 66;
			break;
	}

	pantabase.render(renderer);

	//パンタA1
	GL11.glPushMatrix();
	renderer.rotate(pAro1, 'X', 0.0, 2.8784, pDis + 0.5224);
	pantaA11.render(renderer);
	renderer.rotate(-pAro2, 'X', 0.0, 3.6729, pDis + 1.5431);
	pantaA12.render(renderer);
	renderer.rotate(pAro2 - pAro1, 'X', 0.0, 4.6101, pDis + 0.0935);
	pantaA13.render(renderer);
	GL11.glPopMatrix();
	GL11.glPushMatrix();
	renderer.rotate(-pAro1, 'X', 0.0, 2.8784, pDis - 0.5224);
	pantaA14.render(renderer);
	renderer.rotate(pAro2, 'X', 0.0, 3.6729, pDis - 1.5431);
	pantaA15.render(renderer);
	GL11.glPopMatrix();

	//パンタA2
	GL11.glPushMatrix();
	renderer.rotate(pAro1, 'X', 0.0, 2.8784, -pDis + 0.5224);
	pantaA21.render(renderer);
	renderer.rotate(-pAro2, 'X', 0.0, 3.6729, -pDis + 1.5431);
	pantaA22.render(renderer);
	renderer.rotate(pAro2 - pAro1, 'X', 0.0, 4.6101, -pDis + 0.0935);
	pantaA23.render(renderer);
	GL11.glPopMatrix();
	GL11.glPushMatrix();
	renderer.rotate(-pAro1, 'X', 0.0, 2.8784, -pDis - 0.5224);
	pantaA24.render(renderer);
	renderer.rotate(pAro2, 'X', 0.0, 3.6729, -pDis - 1.5431);
	pantaA25.render(renderer);
	GL11.glPopMatrix();

	//パンタB1
	GL11.glPushMatrix();
	renderer.rotate(pBro1, 'X', 0.0, 2.8784, pDis - 0.5224);
	pantaB11.render(renderer);
	renderer.rotate(-pBro2, 'X', 0.0, 3.8526, pDis + 0.93);
	pantaB12.render(renderer);
	renderer.rotate(pBro2 - pBro1, 'X', 0.0, 4.6227, pDis + 0.0229);
	pantaB13.render(renderer);
	GL11.glPopMatrix();
	GL11.glPushMatrix();
	renderer.rotate(-pBro1, 'X', 0.0, 2.8784, pDis + 0.5224);
	pantaB14.render(renderer);
	renderer.rotate(pBro2, 'X', 0.0, 3.8526, pDis - 0.93);
	pantaB15.render(renderer);
	GL11.glPopMatrix();

	//パンタB2
	GL11.glPushMatrix();
	renderer.rotate(pBro1, 'X', 0.0, 2.8784, -pDis - 0.5224);
	pantaB21.render(renderer);
	renderer.rotate(-pBro2, 'X', 0.0, 3.8526, -pDis + 0.93);
	pantaB22.render(renderer);
	renderer.rotate(pBro2 - pBro1, 'X', 0.0, 4.6227, -pDis + 0.0229);
	pantaB23.render(renderer);
	GL11.glPopMatrix();
	GL11.glPushMatrix();
	renderer.rotate(-pBro1, 'X', 0.0, 2.8784, -pDis + 0.5224);
	pantaB24.render(renderer);
	renderer.rotate(pBro2, 'X', 0.0, 3.8526, -pDis - 0.93);
	pantaB25.render(renderer);
	GL11.glPopMatrix();

	//パンタC1
	GL11.glPushMatrix();
	renderer.rotate(pCro1, 'X', 0.0, 3.0118, pDis - 0.314);
	pantaC11.render(renderer);
	GL11.glPushMatrix();
	renderer.rotate(-pCro4, 'X', 0.0, 3.6084, pDis + 0.7523);
	pantaC14.render(renderer);
	GL11.glPopMatrix();
	renderer.rotate(-pCro2, 'X', 0.0, 3.7151, pDis + 0.8641);
	pantaC12.render(renderer);
	GL11.glPushMatrix();
	renderer.rotate(pCro2 - pCro1, 'X', 0.0, 4.5998, pDis - 0.6186);
	pantaC13.render(renderer);
	GL11.glPopMatrix();
	renderer.rotate(pCro5, 'X', 0.0, 3.5258, pDis + 0.9758);
	pantaC15.render(renderer);
	GL11.glPopMatrix();

	//パンタC2
	GL11.glPushMatrix();
	renderer.rotate(pCro1, 'X', 0.0, 3.0118, -pDis - 0.314);
	pantaC21.render(renderer);
	GL11.glPushMatrix();
	renderer.rotate(-pCro4, 'X', 0.0, 3.6084, -pDis + 0.7523);
	pantaC24.render(renderer);
	GL11.glPopMatrix();
	renderer.rotate(-pCro2, 'X', 0.0, 3.7151, -pDis + 0.8641);
	pantaC22.render(renderer);
	GL11.glPushMatrix();
	renderer.rotate(pCro2 - pCro1, 'X', 0.0, 4.5998, -pDis - 0.6186);
	pantaC23.render(renderer);
	GL11.glPopMatrix();
	renderer.rotate(pCro5, 'X', 0.0, 3.5258, -pDis + 0.9758);
	pantaC25.render(renderer);
	GL11.glPopMatrix();

	//パンタD1
	GL11.glPushMatrix();
	renderer.rotate(-pCro1, 'X', 0.0, 3.0118, pDis + 0.3140);
	pantaD11.render(renderer);
	GL11.glPushMatrix();
	renderer.rotate(pCro4, 'X', 0.0, 3.6084, pDis - 0.7523);
	pantaD14.render(renderer);
	GL11.glPopMatrix();
	renderer.rotate(pCro2, 'X', 0.0, 3.7151, pDis - 0.8641);
	pantaD12.render(renderer);
	GL11.glPushMatrix();
	renderer.rotate(-pCro2 + pCro1, 'X', 0.0, 4.5998, pDis + 0.6186);
	pantaD13.render(renderer);
	GL11.glPopMatrix();
	renderer.rotate(-pCro5, 'X', 0.0, 3.5258, pDis - 0.9758);
	pantaD15.render(renderer);
	GL11.glPopMatrix();

	//パンタD2
	GL11.glPushMatrix();
	renderer.rotate(-pCro1, 'X', 0.0, 3.0118, -pDis + 0.314);
	pantaD21.render(renderer);
	GL11.glPushMatrix();
	renderer.rotate(pCro4, 'X', 0.0, 3.6084, -pDis - 0.7523);
	pantaD24.render(renderer);
	GL11.glPopMatrix();
	renderer.rotate(pCro2, 'X', 0.0, 3.7151, -pDis - 0.8641);
	pantaD22.render(renderer);
	GL11.glPushMatrix();
	renderer.rotate(-pCro2 + pCro1, 'X', 0.0, 4.5998, -pDis + 0.6186);
	pantaD23.render(renderer);
	GL11.glPopMatrix();
	renderer.rotate(-pCro5, 'X', 0.0, 3.5258, -pDis - 0.9758);
	pantaD25.render(renderer);
	GL11.glPopMatrix();
}


//##### render_方向幕 ####################
function render_sign(entity, pass, par3, Middle) {

	var varsion = MCVersionChecker();
	var st8 = 0;
	var st9 = 0

	if (entity != null) {
		if (varsion == "1.7.10" || varsion == "1.8.9" || varsion == "1.9.4") {
			st8 = Math.floor(entity.getTrainStateData(9));
			st9 = Math.floor(entity.getTrainStateData(8));
		} else {
			st8 = Math.floor(entity.getVehicleState(TrainState.getStateType(9)));
			st9 = Math.floor(entity.getVehicleState(TrainState.getStateType(8)));
		}

	}

	if (st8 < 0 && st8 > 33) { st8 = 0; }
	if (st9 < 0 && st9 > 33) { st9 = 0; }

	GL11.glPushMatrix();
	s_t[st8].render(renderer);
	s_d[st9].render(renderer);
	GL11.glPopMatrix();


}
